#$ifndef self_illum
OPTION ARB_precision_hint_nicest;
#$endif

TEMP	light, color, R1, R2, localNormal, specular, diffuse, specLook;

#PARAM   subOne = { -1, -1, -1, -1 };
#PARAM   scaleTwo = { 2, 2, 2, 2 };
#PARAM   subOne = { -1.0625, -1.0625, -1.0625, -1.0625 };
#PARAM   scaleTwo = { 2.125, 2.125, 2.125, 2.125 };
#PARAM   subOne = { -1.03125, -1.03125, -1.03125, -1.03125 };
#PARAM   scaleTwo = { 2.0625, 2.0625, 2.0625, 2.0625 };
PARAM   subOne = { -1.015625, -1.015625, -1.015625, -1.015625 };
PARAM   scaleTwo = { 2.03125, 2.03125, 2.03125, 2.03125 };

PARAM	grayscale = { 0.3, 0.59, 0.11, 0.0 };

# instead of using the normalization cube map, normalize with math
DP3	specular.x, fragment.texcoord[6], fragment.texcoord[6];
RSQ	specular.x, specular.x;
MUL	specular, specular.x, fragment.texcoord[6];
#-----------------

#$ifdef 	parallax
	TEMP 	height, viewofs, _bumpTC, _diffTC, _specTC, _lookTC;

	#MUL 	viewofs.xyzw, fragment.texcoord[7], fragment.texcoord[7];
	DP3		viewofs.w, fragment.texcoord[7], fragment.texcoord[7];
	RSQ 	viewofs.w, viewofs.w;
	MUL 	viewofs.xyzw, viewofs.w, fragment.texcoord[7];

	#NRM 	viewofs.xyzw, fragment.texcoord[7];		#This is for NV_fragment_program2 ONLY !!!

	# load heightmap
	TXB		height, fragment.texcoord[7], $heightMap, 2D;		#texture[7], 2D;
	#TXB		height, fragment.texcoord[1], $heightMap, 2D;	#texture[7], 2D;
	#TXB		height, fragment.texcoord[7], $bumpMap, 2D;		#texture[1], 2D;
	#TXB		height, fragment.texcoord[1], $bumpMap, 2D;		#texture[1], 2D;

	MAD		height, height, program.local[0].x, program.local[0].y; # scale and bias
#	MAD		height.x, height.z, -0.0005, 0.0005;	#, -0.0525, 0.0525;	#-0.0425, 0.0425;	#-0.0375, 0.0375;
#	#MUL 	height.x, height.x, -0.0005;
#	#MUL 	height.z, height.z, 0.0005;

	MAD 	_bumpTC, viewofs, height.xxxx, fragment.texcoord[1];
	MAD 	_diffTC, viewofs, height.xxxx, fragment.texcoord[4];
	MAD 	_specTC, viewofs, height.xxxx, fragment.texcoord[5];
	#MAD 	_lookTC, viewofs, height.xxxx, fragment.texcoord[6];
	MAD 	_lookTC, viewofs, height.xxxx, specular;
#$else
#	ATTRIB 	_bumpTC = fragment.texcoord[1];						#fragment.texcoord[1];
#	ATTRIB 	_diffTC = fragment.texcoord[4];
#	ATTRIB 	_specTC = fragment.texcoord[5];
#	#ATTRIB 	_specTC = fragment.texcoord[6];
#	ATTRIB 	_lookTC = specular;									#fragment.texcoord[6];
#$endif

$ifdef enable_detail
TEMP DTLCOORD;
MAD DTLCOORD.xy, _bumpTC, $detailMult, $detailMult.zwzw;
$endif

$ifdef enable_instdither
MUL R1.xy, fragment.position, 0.0625;
TXB R1, R1, $noiseMap, 2D;
SLT R1.w, _lookTC.w, R1.w;
KIL	-R1.w;
$endif

$ifdef enable_separate_depth
TXB		R1, fragment.texcoord[2].zwzw, $mask, 2D;
SUB		R1, R1.a, $parameters.x;
KIL		R1;
$endif

# modulate by the diffuse map and constant diffuse factor
TXB		diffuse, _diffTC, $diffuseMap, 2D;

$ifdef enable_detailweight_const
TEMP	weight;
MOV weight, 1;
$endif
$ifdef enable_detailweight_vtxalpha
TEMP	weight;
MOV		weight, fragment.color.a;
$endif
$ifdef enable_detailweight_diffalpha
TEMP	weight;
MOV		weight, diffuse.a;
$endif
$ifdef enable_detailweight_tex
TEMP	weight;
TXB		weight, _diffTC, $detailWeightMap, 2D;
$endif
$ifdef enable_detail
MUL_SAT		weight, weight, _bumpTC.w;	#fragment.texcoord[1].w;
$endif


# coverage dither mask
$ifdef r_useDitherMask
MUL R1.xy, fragment.position, 0.0625;
TXB	R1, R1, $noiseMap, 2D;
SLT R1.w, $coverage, R1.w;
KIL	-R1.w;
#TEMP _R1, _R0;
#MUL		_R1.xy, fragment.position, 0.015625;
#TXB		_R0.r, _R1, $dithermask, 2D;
#SUB		_R0.a, 0.5, _R0.r;
#KIL		_R0.a;
$endif

#$if r_usePerFragmentSpecular
	#$if !r_shaderSkipSpecCubeMaps
		# load the specular half angle first, because
		# the ATI shader gives a "too many indirections" error
		# if this is done right before the texture indirection

		#-----------------
		#TXB	specular, fragment.texcoord[6], $normalCubeMap, CUBE;
		#MAD	specular, specular, scaleTwo, subOne;


		# instead of using the normalization cube map, normalize with math
		#DP3	specular.x, fragment.texcoord[6], fragment.texcoord[6];
		#RSQ	specular.x, specular.x;
		#MUL	specular, specular.x, fragment.texcoord[6];
		#-----------------
	#$endif
#$else
	#TEMP	view;

	# normalize view vector
	#DP3	view.x, fragment.texcoord[6], fragment.texcoord[6];
	#RSQ	view.x, view.x;
	#MUL	view, view.x, fragment.texcoord[6];
#$endif

#
# the amount of light contacting the fragment is the
# product of the two light projections and the surface
# bump mapping
#

# perform the diffuse bump mapping
$if !r_shaderPreferALU
	TXB	light, fragment.texcoord[0], $normalCubeMap, CUBE;
	MAD	light, light, scaleTwo, subOne;
$else
	# instead of using the normalization cube map, normalize with math
	DP3	light.x, fragment.texcoord[0], fragment.texcoord[0];
	RSQ	light.x, light.x;
	MUL	light, light.x, fragment.texcoord[0];
$endif

$if !r_shaderSkipSpecCubeMaps
	$if r_usePerFragmentSpecular
		# calculate the half angle vector in object space
		ADD	_lookTC, _lookTC, light;

		# normalize
		DP3	R1.x, _lookTC, _lookTC;
		RSQ	R1.x, R1.x;
		MUL	_lookTC, R1.x, _lookTC;
	$endif
$endif

TXB	localNormal,_bumpTC, $bumpMap, 2D;
$if !r_dxnNormalMaps
MOV localNormal.x, localNormal.a;
#MOV   localNormal.z, 0.90;	#0.99;
$endif
MAD	localNormal.xyz, localNormal, scaleTwo, subOne;
DP3   localNormal.w, localNormal, localNormal;
RSQ   localNormal.w, localNormal.w;
MUL   localNormal.xyz, localNormal, localNormal.w;
MUL localNormal.zw, localNormal.xyxy, localNormal.xyxy;

ADD_SAT localNormal.z, localNormal, localNormal.w;
ADD localNormal.z, -localNormal, 1.0;
RSQ localNormal.z, localNormal.z;
RCP localNormal.z, localNormal.z;

$ifdef enable_bumpdetail
TEMP   localDetailNormal;
TXB localDetailNormal, DTLCOORD, $bumpDetailMap, 2D;
MOV localDetailNormal.x, localDetailNormal.a;
#MOV   localDetailNormal.z, 0.90;	#0.99;
MAD	localDetailNormal.xy, localDetailNormal, scaleTwo, subOne;
MAD localNormal.xy, weight.x, localDetailNormal, localNormal;

DP3   localDetailNormal.w, localDetailNormal, localDetailNormal;
RSQ   localDetailNormal.w, localDetailNormal.w;
MUL   localDetailNormal.xy, localDetailNormal, localDetailNormal.w;
MUL localDetailNormal.zw, localDetailNormal.xyxy, localDetailNormal.xyxy;

ADD_SAT localDetailNormal.z, localDetailNormal, localDetailNormal.w;
ADD localDetailNormal.z, -localDetailNormal, 1.0;
RSQ localDetailNormal.z, localDetailNormal.z;
RCP localDetailNormal.z, localDetailNormal.z;
$endif

# localNormal filter
MOV		R1.xyz, localNormal;
MOV		R1.z, ZeroFive;
DP3		R1, R1, R1;
MAD_SAT	R1.z, R1.w, -1, 1;
RSQ		R1, R1.z;
RCP		localNormal.z, R1.w;

$if r_normalizeNormalMaps
#MOV		localNormal.z, 0;
#DP3		R1.x, localNormal,localNormal;
#ADD		R1.x, 1, -R1.x;
#RSQ		R1.x, R1.x;
#RCP		localNormal.z, R1.x;
$endif

# localNormal filter
ADD_SAT	R1, _bumpTC, 0;
TXB		R2, R1, $bumpMap, 2D;		#texture[1], 2D;
MOV 	R2.x, R2.a;
MAD_SAT	R2, R2, scaleTwo, subOne;

PARAM   scaleTwoX = { 4.03125, 4.03125, 4.03125, 4.03125 };
PARAM   subOneX = { -3.015625, -3.015625, -3.015625, -3.015625 };

# flatten normal over distance (Z)
MAD_SAT	R1, fragment.position.z, scaleTwoX, subOneX;
MAX		R1, R1.x, 0;
ADD_SAT	localNormal.z, localNormal.z, R1.x;

DP3_SAT	light.x, light, localNormal;

# boost projection, specular light reaches further - DFM added
#ADD_SAT	R1.xyz, R1, R1;
#MUL	R2.rgb, R2, R1;

# modulate by the light falloff
#TXB	R1.x, fragment.texcoord[2], $lightFalloffMap, 2D;
#MUL	light, light, R1.x;

# compute "length" from diffuse falloff texcoords
SUB	R1.xy, fragment.texcoord[2], 0.375;		#0.7;
MUL	R1.xy, R1, R1;
ADD	R1.w, R1.x, R1.y;
RSQ	R1.w, R1.w;
RCP	R1.w, R1.w;
MUL	R1.w, R1, 0.75;							#0.7;

# modulate by "lenght"
SUB_SAT	light.xyz, light, R1.w;
SUB_SAT	R2.rgb, R2, R1.w;

# modulate by the light projection
TXP	R1, fragment.texcoord[3], $lightProjectionMap, 2D;
MUL	light, light.x, R1;

#
# the light will be modulated by the diffuse and
# specular surface characteristics
#

# modulate by the diffuse map and constant diffuse factor
$ifdef enable_diffdetail
TEMP    detailDiff;
TXB		detailDiff, DTLCOORD, $diffuseDetailMap, 2D;
ADD		detailDiff, detailDiff, -0.5;
MAD		diffuse, weight.x, detailDiff, diffuse;
$endif

$ifdef alphatest_kill
SUB		R1.a, diffuse.a, $alphaThresh;
KIL		R1.a;
$endif

MUL diffuse, diffuse, fragment.color;


MUL	color, diffuse, $diffuseColor;

$if !r_shaderSkipSpecCubeMaps
	# perform the specular bump mapping
	DP3	_lookTC.x, _lookTC, localNormal;

	$if !r_shaderPreferALU
		# perform a dependent table read for the specular falloff
		TXB	R1, _lookTC, $specularTable, 2D;
	$else
		# Specular falloff: (sat(4x-3))^2 matches the function inside the specular table texture
		#MAD_SAT R1.x, _lookTC.x, 4.0, -3.0;
		#PARAM specExp = { 16, 0, 0, 0 };
		PARAM	specExp = { 12, 0, 0, 0 };
		POW_SAT R1.x, _lookTC.x, specExp.x;
		#MUL R1.x, R1.x, R1.x;
	$endif

	# no color please!
	ADD	R1, R1.x, R1;

	# modulate by the constant specular factor
	MUL	R1, R1.x, $specularColor;

	# modulate by the specular map * 2
	TXB	R2, _specTC, $specularMap, 2D;
	#TXB	R2, _bumpTC, $specularMap, 2D;
	#ADD	R2, R2, R2;

	# modulate by the constant specular factor
	#MUL R2.rgb, R2.x, $diffuseColor;

	# no color please!
	#ADD	R2.rgb, R2.x, R2;

	$ifdef enable_specdetail
		TXB		specLook, DTLCOORD, $specDetailMap, 2D;
		ADD		specLook, specLook, -0.5;
		MAD		R2, weight.x, specLook, R2;
	$endif

	MAD	color, R1, R2, color;
$endif

TEMP _finalcolor;
MUL	_finalcolor.rgb, light, color;
$ifdef ambient
MAD _finalcolor.rgb, diffuse, $ambientAvgColor, _finalcolor;
$endif

$ifdef self_illum
	# Simple self illumination
	TXB		R1, _diffTC, $selfIllumMap, 2D;
	$ifdef self_illum_glow
		MAD_SAT R1.rgb, R1.a, $parameters2, R1;
	$endif
	ADD _finalcolor, R1, _finalcolor;
$endif

$ifdef strogg_effects
# "Beetle shell" empirical shader
DP3		R1, _lookTC, localNormal;
TXB		R2, R1, $stroggShellMap, 2D;
MAD		R1,	R1, 0.2, 0.01;
MUL		R2, R1, R2;
MUL		R2, $sunColor, R2; #so it goes dimmer at night
ADD		_finalcolor, _finalcolor, R2;
$endif


$if ( r_megaDrawMethod != 0 )
$ifdef amblit
LRP result.color.rgb, fragment.color.secondary.x, $fogColor, _finalcolor;
$else
SUB R1.x, 1, fragment.color.secondary.x;
MUL result.color.rgb, _finalcolor, R1.x;
$endif
$else
MOV result.color.rgb, _finalcolor;
$endif

# modify by the vertex color


MUL R1, R1, R2;
MUL R1, R1, light;
DP3 result.color.a, R1, grayscale;

#	MUL viewofs.xyzw, fragment.texcoord[7], fragment.texcoord[7];
#	RSQ viewofs.w, viewofs.w;
#	MUL viewofs.xyzw, viewofs.w, fragment.texcoord[7];

#MAD result.color.rgb, viewofs, 0.5, 0.5;

#MOV		result.color.rgb, fragment.color.secondary;

#MOV result.color.a, 1;

