#=======================================================================
# Brilliant highlights ver 0.3.3			       9.7.2008
#=======================================================================
#
# Version history
# ---------------
#
# New version numbering;
#	0.1.x - per vertex half-angle vector
#	0.2.x - per pixel reflect vector
#	0.3.x - per pixel half-angle vector
#
# 0.3.1 # HQ per pixel half-angle vector model
#	  Backlights
#	  Normal map filtering
#	  "Pocket" shadows (a static effect)
#
#-----------------------------------------------------------------------

!!ARBfp1.0
OPTION ARB_precision_hint_nicest;
#OPTION NV_fragment_program2;

# texture 0 is the cube map
# texture 1 is the per-surface bump map
# texture 2 is the light falloff texture
# texture 3 is the light projection texture
# texture 4 is the per-surface diffuse map
# texture 5 is the per-surface specular map
# texture 6 is the specular lookup table

# env[0] is the diffuse modifier
# env[1] is the specular modifier

TEMP	toLight, light, toViewer, backlight, color, R1, R2, R3, localNormal, mod1, newtexcoord, halfAngle;

#PARAM   subOne = { -1, -1, -1, -1 };
#PARAM   scaleTwo = { 2, 2, 2, 2 };
#PARAM   subOne = { -1.0625, -1.0625, -1.0625, -1.0625 };
#PARAM   scaleTwo = { 2.125, 2.125, 2.125, 2.125 };
#PARAM   subOne = { -1.03125, -1.03125, -1.03125, -1.03125 };
#PARAM   scaleTwo = { 2.0625, 2.0625, 2.0625, 2.0625 };
PARAM   subOne = { -1.015625, -1.015625, -1.015625, -1.015625 };
PARAM   scaleTwo = { 2.03125, 2.03125, 2.03125, 2.03125 };

#PARAM	xero = { 0, 0, 0, 1 };
PARAM	saab = { 0, 0, 0, 0.5 };	# specular AA bias

##PARAM specExp = { 24, 0, 0, 0 };
#PARAM	specExp = { 16, 0, 0, 0 };

#PARAM	pointFive = { 0.5, 0.5, 0.5, 0.5 };

#########################################################
############## adjustable parameters ####################
#########################################################

# Maximum power (shinyness, default 48.0)
PARAM	maxpow = 32.0;		#12.0;

# Minimum power	(default 16.0)
PARAM	minpow = 2.0;		#4.0;

# Backlight scatter (0.0 - 1.0, default 0.33)
PARAM	blscatter = 0.33;	#0.2475;

# Backlight strenght (0.0 - 1.0, default 0.15)
PARAM	blstr = 0.1;

#########################################################

PARAM	GlobalLight = 1.0;
PARAM	ZeroFive = 0.05;
#PARAM   scaleTwoX = { 4, 4, 4, 4 };
#PARAM   subOneX = { -3, -3, -3, -3 };
PARAM   scaleTwoX = { 4.03125, 4.03125, 4.03125, 4.03125 };
PARAM   subOneX = { -3.015625, -3.015625, -3.015625, -3.015625 };
#PARAM   scaleTwoX = { 8, 8, 8, 8 };
#PARAM   subOneX = { -7, -7, -7, -7 };
PARAM   scaleTwoZ = { 16, 16, 16, 16 };
PARAM   subOneZ = { -15, -15, -15, -15 };
PARAM   scaleTwoY = -1;
PARAM   subOneY = 1;

# ----------------------------------- normalize -- #

# specular is actually now viewer
#DP3	specular, fragment.texcoord[6], fragment.texcoord[6];
#RSQ	specular, specular.x;
#MUL	specular.xyz, specular.w, fragment.texcoord[6];

# light
#TXB	light, fragment.texcoord[0], texture[0], CUBE;
#MAD	light.xyz, light, scaleTwo, subOne;

# normalize the direction to the light
TXB		toLight, fragment.texcoord[0], texture[0], CUBE;
MAD		toLight.xyz, toLight, scaleTwo, subOne;

# normalize the direction to the viewer
DP3		toViewer, fragment.texcoord[6], fragment.texcoord[6];
RSQ		toViewer, toViewer.x;
MUL		toViewer.xyz, toViewer.w, fragment.texcoord[6];

#$ifdef 	parallax
	TEMP	height, view, newbumpcoord, newspeccoord, newspeclook;	#, newheighttexcoord;

	#MUL		view.xyzw, fragment.texcoord[7], fragment.texcoord[7];
	DP3		view.w, fragment.texcoord[7], fragment.texcoord[7];
	RSQ		view.w, view.w;
	MUL		view.xyzw, view.w, fragment.texcoord[7];

	#NRM 	view.xyzw, fragment.texcoord[7];	#This is for NV_fragment_program2 ONLY !!!

	# load heightmap
	TXB		height, view, texture[7], 2D;
	#TXB		height, fragment.texcoord[1], texture[7], 2D;

	MAD		height, height, program.local[0].x, program.local[0].y; 	# scale and bias
#	MAD		height.x, height.z, -0.0005, 0.0005;	#, -0.0525, 0.0525;	#-0.0425, 0.0425;	#-0.0375, 0.0375;
#	#MUL 	height.x, height.x, -0.0005;
#	#MUL 	height.z, height.z, 0.0005;

#	MAD		newheighttexcoord, height.xxxx, view, fragment.texcoord[1];
	MAD		newbumpcoord, height.xxxx, view, fragment.texcoord[1];
	MAD		newtexcoord, height.xxxx, view, fragment.texcoord[4];
	MAD		newspeccoord, height.xxxx, view, fragment.texcoord[5];
	#MAD		newspeclook, height.xxxx, view, fragment.texcoord[6];
	MAD		newspeclook, height.xxxx, view, toViewer;
#$endif

# localNormal (load)
TXB	localNormal, newbumpcoord, texture[1], 2D;
MOV localNormal.x, localNormal.a;
#MOV	localNormal.z, 0.875;	#0.99;
MAD	localNormal, localNormal, scaleTwo, subOne;
DP3 localNormal.w, localNormal, localNormal;
RSQ localNormal.w, localNormal.w;
MUL localNormal.xyz, localNormal.w, localNormal;
MUL localNormal.zw, localNormal.xyxy, localNormal.xyxy;

ADD_SAT localNormal.z, localNormal, localNormal.w;
ADD 	localNormal.z, -localNormal, GlobalLight;
RSQ 	localNormal.z, localNormal.z;
RCP 	localNormal.z, localNormal.z;

# soften
LRP		localNormal.xyz, program.local[6].x, newspeclook, localNormal;

# normalize localNormal
#DP3   localNormal.w, localNormal, localNormal;
#RSQ   localNormal.w, localNormal.w;
#MUL   localNormal.xyz, localNormal, localNormal.w;

# localNormal filter
MOV		R1.xyz, localNormal;
MOV		R1.z, 0.0;
DP3		R1, R1, R1;
MAD_SAT	R1.z, R1.w, scaleTwoY, subOneY;	#-1, 1;
RSQ		R1, R1.z;
RCP		localNormal.z, R1.w;

# localNormal filter
#MOV		localNormal.z, 0.0;
#DP3		R1.x, localNormal, localNormal;
#ADD_SAT	R1.x, 1, -R1.x;
#RSQ		R1.x, R1.x;
#RCP		localNormal.z, R1.x;

# localNormal filter
ADD_SAT	R1, newbumpcoord, saab;
TXB		R2, R1, texture[1], 2D;		#TXB
MOV 	R2.x, R2.a;
MAD_SAT	R2, R2, scaleTwo, subOne;

ADD	localNormal, localNormal, R2;
MUL	localNormal, localNormal, 0.5;

# flatten normal over distance (Z)
MAD_SAT	R1.w, fragment.position.z, scaleTwoX, subOneX;	#4.0, -3.5;
MAX		R1.w, R1.w, 0.0;
ADD_SAT	localNormal.z, localNormal.z, R1.w;

# localNormal (normalize)
DP3		R1.w, localNormal, localNormal;
RSQ		R1.w, R1.w;
MUL		localNormal.xyz, R1.w, localNormal;

# normalize the bumpmap
#DP3		R1, localNormal, localNormal;
#RSQ		R1, R1.x;
#MUL		localNormal.xyz, localNormal, R1.x;

#TXB		localNormal, localNormal, texture[0], CUBE;
#MAD		localNormal, localNormal, scaleTwoX, subOneX;

# --------------------------------------- dots -- #

# produce diffuse falloff
DP3	light.w, toLight, localNormal;

# halfangle makes a return... normalized halfangle
#ADD	halfAngle.xyz, newspeclook, toLight;	#, light;
#DP3	R1.xyz, halfAngle, halfAngle;
#RSQ	R1.w, R1.x;
#MUL	halfAngle.xyz, halfAngle, R1.w;

# specular falloff (raw)
#DP3_SAT	R1.w, halfAngle, localNormal;

# calculate the halfangle vector and normalize
ADD		halfAngle.xyz, newspeclook, toLight;	#, light;
DP3		R1.xyz, halfAngle, halfAngle;
RSQ		R1.w, R1.x;
MUL		halfAngle.xyz, R1.w, halfAngle;
#MUL		halfAngle.xyz, halfAngle, R1.w;

# calculate specular
DP3_SAT	R1.w, halfAngle, localNormal;

# perform the specular bump mapping
DP3 halfAngle.w, halfAngle, localNormal;
#DP3 newspeclook.w, newspeclook, localNormal;

# create backlight
ADD_SAT	backlight.w, -light.w, blscatter;		# backlight scatter	(def. 0.33)
MUL	backlight.w, backlight.w, blstr;			# backlight fade	(def. 0.15)

# -------------------------- modulate diffuse  -- #

# modulate by the light projection
TXP	R2.rgb, fragment.texcoord[3], texture[3], 2D;
MUL	mod1.rgb, program.env[0], R2;

# modulate by diffuse map
TXB		R1.rgb, newtexcoord, texture[4], 2D;
#TXB	R1.rgb, newbumpcoord, texture[4], 2D;
#TXB	color.rgb, newtexcoord, texture[4], 2D;
#TXB	color.rgb, newbumpcoord, texture[4], 2D;
MUL		color.rgb, mod1, R1;

# diffuse to backlight
MUL		backlight.rgb, R1, backlight.w;
MUL_SAT	R2.rgb, mod1, 3.0;
MUL		backlight.rgb, R2, backlight;

MUL_SAT	color.rgb, color, light.w;

# turn highlight to light color
#MUL	R1.xyz, R1.w, program.env[1];
# no color please!
#ADD	R1.xyz, R1.w, R1;

# ----------------------------------- specular -- #

# R3 is the specular map (* 2)
TXB	R3.rg, newspeccoord, texture[5], 2D;
##TXB		R3.rg, newbumpcoord, texture[5], 2D;

# no color please ?
ADD	R3.rg, R3.x, R3;	#Activate this line (uncomment) only on Q4 !!!

# modulate specular
#MUL	R3.rg, R3.x, mod1;

# MIN + MAX power to R1.w (modulated by specular map)
MAD	R1.w, R3.y, maxpow, minpow;

# pow specular
POW_SAT	R2.rgb, halfAngle.w, R1.w;

# mask specular with specular map
MUL	R2.rgb, R2, R3.x; # x is mask, y is pow

# ----------------------------------------------- #

# no color please!
#ADD	R2.rgb, R2.x, R2;

# modulate specular
MUL	R2.rgb, R2.x, mod1;

# add specular & backlight
ADD	color.rgb, color, backlight;
ADD	color.rgb, color, R2;
#MAD	color.rgb, R1, R2, color;

# modulate by falloff (look up)
TXB	R1.r, fragment.texcoord[2], texture[2], 2D;
MUL	color.rgb, color, R1.r;

# --------------------------------------------- #

# light color
##MUL 	color.rgb, color, program.env[0];
#MUL	color.rgb, mod1, color;

# modify by the vertex color
#MUL result.color.rgb, color, fragment.color;

#END

#-----------------------------------------
OUTPUT oCol = result.color;

ATTRIB v0 = fragment.color;

# PARAM white = {1.0, 1.0, 1.0, 1.0};
#-----------------------------------------

#MOV oCol.rgb, v0;
MUL oCol.rgb, color, v0;

END
