!!ARBfp1.0
OPTION ARB_precision_hint_nicest;
OPTION NV_fragment_program2;

TEMP	toLight, light, toViewer, color, R1, R2, localNormal, halfAngle;	#, specular;

#PARAM	subOne = { -1, -1, -1, -1 };
#PARAM	scaleTwo = { 2, 2, 2, 2 };
#PARAM   subOne = { -1.0625, -1.0625, -1.0625, -1.0625 };
#PARAM   scaleTwo = { 2.125, 2.125, 2.125, 2.125 };
#PARAM   subOne = { -1.03125, -1.03125, -1.03125, -1.03125 };
#PARAM   scaleTwo = { 2.0625, 2.0625, 2.0625, 2.0625 };
PARAM   subOne = { -1.015625, -1.015625, -1.015625, -1.015625 };
PARAM   scaleTwo = { 2.03125, 2.03125, 2.03125, 2.03125 };

PARAM	specExp = { 8, 0, 0, 0 };
#PARAM	specExp = { 12, 0, 0, 0 };

#PARAM	pointFive = { 0.5, 0.5, 0.5, 0.5 };

PARAM	GlobalLight = 1.0;
PARAM	ZeroFive = 0.05;
PARAM   scaleTwoX = { 4, 4, 4, 4 };
PARAM   subOneX = { -3, -3, -3, -3 };
#PARAM   scaleTwoX = { 8, 8, 8, 8 };
#PARAM   subOneX = { -7, -7, -7, -7 };
PARAM   scaleTwoZ = { 16, 16, 16, 16 };
PARAM   subOneZ = { -15, -15, -15, -15 };
#PARAM   scaleTwoY = { -1, -1, -1, -1 };
#PARAM   subOneY = { 1, 1, 1, 1 };
PARAM   scaleTwoY = -1;
PARAM   subOneY = 1;

#
# the amount of light contacting the fragment is the
# product of the two light projections and the surface
# bump mapping
#

# normalize the direction to the light
#DP3		toLight.w, fragment.texcoord[0], fragment.texcoord[0];
#RSQ		toLight.w, toLight.w;
#MUL		toLight.xyz, toLight.w, fragment.texcoord[0];

TXL		toLight, fragment.texcoord[0], texture[0], CUBE;
MAD		toLight.xyz, toLight, scaleTwo, subOne;

# normalize the direction to the viewer
#DP3		toViewer.x, fragment.texcoord[6], fragment.texcoord[6];
#RSQ		toViewer.x, toViewer.x;
#MUL		toViewer.xyz, toViewer.x, fragment.texcoord[6];

#TXL		toViewer, fragment.texcoord[6], texture[0], CUBE;
#MAD		toViewer.xyz, toViewer, scaleTwo, subOne;

NRM toViewer.xyz, fragment.texcoord[6];
#NRM toLight.xyz, fragment.texcoord[0];

#$ifdef 	parallax
	TEMP	height, view, newbumpcoord, newtexcoord, newheighttexcoord, newspeccoord, newspeclook;

	# load heightmap
	TXL		R1, fragment.texcoord[1], texture[7], 2D;
	MAD		R1, R1, program.local[0].x, program.local[0].y; # scale and bias
	MAD		newheighttexcoord, R1, toViewer, fragment.texcoord[1];

	##MUL		view.xyzw, fragment.texcoord[7], fragment.texcoord[7];
	#DP3		view.w, fragment.texcoord[7], fragment.texcoord[7];
	#RSQ		view.w, view.w;
	#MUL		view.xyzw, view.w, fragment.texcoord[7];

	NRM 	view.xyz, fragment.texcoord[7];

	TXL		height, fragment.texcoord[4], texture[7], 2D;			#heightmap
#	TXL		height, fragment.texcoord[4], texture[1], 2D;			#bumpmap
#	TXL		height, newheighttexcoord, texture[7], 2D;				#heightmap
##	TXL		height, newheighttexcoord, texture[1], 2D;				#bumpmap
	MAD		height.x, height.z, -0.0005, 0.0005;	#, -0.0525, 0.0525;	#-0.0425, 0.0425;	#-0.0375, 0.0375;
	#MUL 	height.x, height.x, -0.0005;
	#MUL 	height.z, height.z, 0.0005;

	#MAD		newbumpcoord, height.x, view, fragment.texcoord[1];
	MAD		newbumpcoord, height.x, view, newheighttexcoord;		#fragment.texcoord[1];
	MAD		newtexcoord, height.x, view, fragment.texcoord[4];
	MAD		newspeccoord, height.x, view, fragment.texcoord[5];
	MAD		newspeclook, height.x, view, toViewer;					#fragment.texcoord[6];
	##MAD		newspeclook, height.x, view, fragment.texcoord[6];
#$endif

# localNormal (load)
TXL	localNormal, newbumpcoord, texture[1], 2D;
MOV	localNormal.x, localNormal.a;
#MOV	localNormal.z, 0.875;	#0.99;
MAD	localNormal.xyz, localNormal, scaleTwo, subOne;
NRM localNormal.xyz, localNormal;
MUL localNormal.zw, localNormal.xyxy, localNormal.xyxy;

ADD_SAT localNormal.z, localNormal, localNormal.w;
ADD 	localNormal.z, -localNormal, GlobalLight;
RSQ 	localNormal.z, localNormal.z;
RCP 	localNormal.z, localNormal.z;

# soften
LRP	localNormal.xyz, program.local[6].x, newspeclook, localNormal;

# normalize localNormal
#DP3   localNormal, localNormal, localNormal;
#RSQ   localNormal, localNormal.w;
#MUL   localNormal.xyz, localNormal.w, localNormal;

# localNormal filter
MOV		R1.xyz, localNormal;
MOV		R1.z, ZeroFive;
DP3		R1, R1, R1;
MAD_SAT	R1.z, R1.w, scaleTwoY, subOneY;
RSQ		R1, R1.z;
RCP		localNormal.z, R1.w;

# localNormal filter
#MOV		localNormal.z, ZeroFive;
#DP3		R1.x, localNormal, localNormal;
#ADD_SAT	R1.x, 1, -R1.x;
#RSQ		R1.x, R1.x;
#RCP		localNormal.z, R1.x;

# localNormal filter
ADD_SAT	R1, newbumpcoord, ZeroFive;
TXL		R2, R1, texture[1], 2D;
MOV 	R2.x, R2.a;
MAD_SAT	R2, R2, scaleTwo, subOne;

#ADD	localNormal, localNormal, R2;
#MUL	localNormal, localNormal, 0.5;

# flatten normal over distance (Z)
MAD_SAT	R1, fragment.position.z, scaleTwoX, subOneX;
MAX		R1, R1.x, ZeroFive;
ADD_SAT	localNormal.z, localNormal.z, R1.x;

# normalize the bumpmap
#DP3		R1, localNormal, localNormal;
#RSQ		R1, R1.x;
#MUL		localNormal.xyz, localNormal, R1.x;

NRM		localNormal.xyz, localNormal;

#TXL		localNormal, localNormal, texture[0], CUBE;
#MAD		localNormal, localNormal, scaleTwo, subOne;

# normalize the bumpmap
#DP3		R1.w, localNormal, localNormal;
#RSQ		R1.w, R1.w;
#MUL		localNormal.xyz, R1.w, localNormal;

DP3	light, toLight, localNormal;

# modulate by falloff (look up)
TXL	R1.xyz, fragment.texcoord[2], texture[2], 2D;
MUL	light.xyz, light, R1;

# modulate by the light projection
TXP	R1.xyz, fragment.texcoord[3], texture[3], 2D;
MUL	light.xyz, light, R1;

# modulate by the diffuse map and constant diffuse factor
TXL	R1.rgb, newtexcoord, texture[4], 2D;
#TXL	R1.rgb, newbumpcoord, texture[4], 2D;
#TXL		color.rgb, newtexcoord, texture[4], 2D;
#TXL	color.rgb, newbumpcoord, texture[4], 2D;
MUL	color.rgb, R1, program.env[0];

# no color please!
#ADD	R1.xyz, R1, R1;

# calculate the half angle vector and normalize
ADD		halfAngle.xyz, newspeclook, toLight;
#DP3		R1.x, halfAngle, halfAngle;
#RSQ		R1.x, R1.x;
#MUL		halfAngle.xyz, R1.x, halfAngle;
##MUL	halfAngle.xyz, halfAngle, R1.x;

NRM		halfAngle.xyz, halfAngle;

# calculate specular
DP3_SAT	R1.x, halfAngle, localNormal;

# perform the specular bump mapping
#DP3 halfAngle.xyz, newspeclook, localNormal;
DP3 halfAngle.xyz, halfAngle, localNormal;

# modulate falloff by diffusemap alpha
RCP   R2, R1.x;
MUL   R2, specExp, R2;

# perform a dependent table read for the specular falloff
##TXL	R1, halfAngle.x, texture[6], 2D;

# calculate specular falloff with maths
POW_SAT   R1, halfAngle.x, R2.x;
#POW_SAT R1, halfAngle.x, specExp.x;
#MAD_SAT R1, R1.x, 16, -15;		#ALTERNATIVO CON ACCENTUAZIONE SPECULARE
#MAD_SAT R1, R1.x, 10.0, -8.5;
#MAD_SAT R1, R1.x, 4.0, -3.0;	#VERSIONE DI HUMUS ESTREMAMENTE SIMILE ALL'ORIGINALE
#MUL 	 R1, R1.x, R1.x;

# no color please!
ADD	R1.xyz, R1.x, R1;

# modulate by the constant specular factor
MUL 	R1.xyz, R1.x, program.env[1];

# modulate by the specular map * 2
TXL		R2.rgb, newspeccoord, texture[5], 2D;
#TXL	R2.rgb, newbumpcoord, texture[5], 2D;
#ADD	R2, R2, R2;
#ADD	R2, R2, 0.121875;
#ADD	R2, R2, 0.2575;
#ADD	R2, R2, 0.01875;
#ADD	R2, 0.7, 0.175;
#MUL	R2, R2, 1.4;

# no color please!
#ADD	R2.rgb, R2.x, R2;

# modulate by the constant specular factor
#MUL R2.rgb, R2.x, program.env[0];

MAD	color.rgb, R1, R2, color;
MUL	color.rgb, light, color;

# light color
#MUL color.rgb, color, program.env[0];

# global illumination trick
#MUL	R1.x, localNormal.z, 0.99;	#1.015625;	#GlobalLight;
#MUL	R1.x, R1, R1;
#MUL	color.xyz, color, R1.x;

# modify by the vertex color
#MUL	result.color.rgb, color, fragment.color;

#-----------------------------------------
OUTPUT oCol = result.color;

ATTRIB v0 = fragment.color;

# PARAM white = {1.0, 1.0, 1.0, 1.0};
#-----------------------------------------

MOV oCol.rgb, v0;

END
